/*!
 * Copyright (c) what3words http://what3words.com
 */
import { d as distExports } from './sdk.js';
import { D as DEFAULTS, P as PHRASE_PARAMETER_PLACEHOLDER } from './constants.js';
import { a as isKey } from './utils.js';

/** GENERATED FILE - DO NOT MODIFY */
const af = Object.freeze({
    correction_message: "Het jy bedoel?",
    distance: "${PARAM} km",
    error_message: "'n Fout het voorgekom. Probeer asb later weer.",
    input_hint: "b.v. ///biltong.vaswerk.gesluit",
    invalid_address_message: "Geen geldige what3words-adres gevind nie",
    voice_placeholder: "Sê 'n 3-woord-adres...",
});
const am = Object.freeze({
    correction_message: "ማለትዎ ነው?",
    distance: "${PARAM} ኪ.ሜ",
    error_message: "ስህተት ተፈጥሯል፡፡ እባክዎን እንደገና ይሞክሩ",
    input_hint: "ለምሳሌ ///ዘይት.ያማሩ.አወቁ",
    invalid_address_message: "ትክክለኛ የ3 ቃላት አድራሻ አልተገኘም",
    voice_placeholder: "ባለ3 ቃላት አድራሻ ይናገሩ...",
});
const ar = Object.freeze({
    correction_message: "هل تعني؟",
    distance: "${PARAM} كم",
    error_message: "حدث خطأ، يُرجى إعادة المحاولة لاحقًا",
    input_hint: "مثال: ///تنافس.شواطئ.أنام",
    invalid_address_message: "لم يتم العثور على عنوان من ٣ كلمات صالح",
    voice_placeholder: "انطق عنوان من ۳ كلمات...",
});
const bg = Object.freeze({
    correction_message: "Искахте да кажете?",
    distance: "${PARAM} разстояние",
    error_message: "Възникна грешка. Моля, опитайте отново по-късно",
    input_hint: "напр. ///сънливо.внимавам.стрелки",
    invalid_address_message: "Не е намерен валиден адрес what3words",
    invalid_suggestions: "Не са намерени предложения. Моля, опитайте отново.",
    voice_placeholder: "Изречете обръщение от 3 думи...",
});
const bn = Object.freeze({
    correction_message: "আপনি কি এটা বলছেন?",
    distance: "${PARAM} কি.মি.",
    error_message: "একটি ত্রুটি ঘটেছে।পরে আবার চেষ্টা করুন",
    input_hint: "যেমন ///বিষয়ে.হীরা.রাত্রি",
    invalid_address_message: "কোনো বৈধ 3 শব্দের ঠিকানা পাওয়া যায় নি",
    voice_placeholder: "3 শব্দের ঠিকানা বলুন...",
});
const bs = Object.freeze({
    correction_message: "Jeste li mislili...",
    distance: "${PARAM} km",
    error_message: "Došlo je do greške. Pokušajte ponovo kasnije",
    input_hint: "npr. ///usluge.izvođači.brižna",
    invalid_address_message: "Nije pronađena važeća adresa od 3 riječi",
    voice_placeholder: "Recite adresu od 3 riječi…",
});
const ca = Object.freeze({
    correction_message: "Volies dir?",
    distance: "${PARAM} km",
    error_message: "S'ha produït un error. Torna-ho a provar més tard.",
    input_hint: "p. ex., ///esmorzat.aviació.lliurant",
    invalid_address_message: "No s'ha trobat cap adreça de 3 paraules vàlida",
    voice_placeholder: "Digues una adreça de 3 paraules…",
});
const cs = Object.freeze({
    correction_message: "Mysleli jste?",
    distance: "${PARAM} km",
    error_message: "Vyskytla se chyba. Zkuste to prosím později",
    input_hint: "např. ///vyslat.ohyb.zvířata",
    invalid_address_message: "Nebyla nalezena žádná platná 3slovná adresa",
    voice_placeholder: "Řekněte 3slovnou adresu...",
});
const cy = Object.freeze({
    correction_message: "Oeddech chi'n meddwl?",
    distance: "${PARAM} km",
    error_message: "Digwyddodd gwall. Rhowch gynnig arni eto'n hwyrach os gwelwch yn dda",
    input_hint: "e.e. ///marchog.carafannau.pasio",
    invalid_address_message: "Ni chanfyddwyd unrhyw gyfeiriadau what3words dilys",
    voice_placeholder: "Dywedwch gyfeiriad what3words...",
});
const da = Object.freeze({
    correction_message: "Mente du?",
    distance: "${PARAM} km",
    error_message: "Der opstod en fejl. Prøv igen senere.",
    input_hint: "fx ///opsøge.sangbogen.gaflerne",
    invalid_address_message: "Ingen what3words-adresse fundet",
    voice_placeholder: "Sig en 3-ords-adresse",
});
const de = Object.freeze({
    correction_message: "Hast du das gemeint ",
    distance: "${PARAM} km",
    error_message: "Es ist ein Fehler aufgetreten. Versuche es bitte später erneut.",
    input_hint: "z. B. ///abteilung.einrichten.einweisung",
    invalid_address_message: "Keine gültige Dreiwortadresse gefunden",
    voice_placeholder: "Eine Dreiwortadresse sagen ...",
});
const el = Object.freeze({
    correction_message: "Μήπως εννοείς;",
    distance: "${PARAM} χλμ.",
    error_message: "Προέκυψε κάποιο λάθος. Παρακαλώ προσπαθήστε πάλι αργότερα.",
    input_hint: "π.χ. ///πίστεψα.αρχαίο.κέρασε",
    invalid_address_message: "Δεν βρέθηκε έγκυρη διεύθυνση what3words.",
    voice_placeholder: "Πείτε μία διεύθυνση 3 λέξεων...",
});
const en = Object.freeze({
    correction_message: "Did you mean?",
    distance: "${PARAM} km",
    error_message: "An error occurred. Please try again later",
    error_quota: "Usage limit exceeded. Please review higher plans.",
    input_hint: "e.g. ///lock.spout.radar",
    invalid_address_message: "No valid what3words address found",
    invalid_suggestions: "No suggestions found. Please try again.",
    nearest_place: "near ${PARAM}",
    voice_placeholder: "Say a 3 word address…",
});
const es = Object.freeze({
    correction_message: "¿Querías decir?",
    distance: "${PARAM} km",
    error_message: "Ha ocurrido un error. Vuelve a intentarlo más tarde",
    input_hint: "Por ejemplo, ///pare.relee.opino",
    invalid_address_message: "No se han encontrado direcciones de 3 palabras válidas",
    voice_placeholder: "Di una dirección de 3 palabras...",
});
const et = Object.freeze({
    correction_message: "Kas mõtlesid?",
    distance: "${PARAM} km",
    error_message: "Tekkis viga. Palun proovi mõne aja pärast uuesti",
    error_quota: "Kasutuslimiit on ületatud. Palun tutvu suurema mahuga pakettidega.",
    input_hint: "nt. ///rehv.kenasti.koostöö",
    invalid_address_message: "Sobivaid what3words aadresse ei leitud",
    invalid_suggestions: "Ettepanekuid ei leitud. Palun proovi uuesti.",
    voice_placeholder: "Ütle 3-sõnaline aadress...",
});
const fa = Object.freeze({
    correction_message: "آیا منظورت این بود؟",
    distance: "${PARAM} کیلومتر",
    error_message: "خطایی رخ داده است. لطفاً بعداً دوباره آزمایش کن.",
    input_hint: "مثال: ///بگویند.فواره.اهلی",
    invalid_address_message: "هیچ نشانی سه‌کلمه‌ای معتبری در what3words پیدا نشد.",
    voice_placeholder: "یک نشانی سه‌کلمه‌ای بگو!",
});
const fi = Object.freeze({
    correction_message: "Tarkoititko tätä?",
    distance: "${PARAM} km",
    error_message: "Tapahtui virhe. Ole hyvä ja yritä myöhemmin uudelleen.",
    input_hint: "Esim. ///nopeus.makkara.nenät",
    invalid_address_message: "what3words-osoitetta ei löytynyt",
    voice_placeholder: "Sanele 3 sanan osoite…",
});
const fr = Object.freeze({
    correction_message: "C'est bien cela ?",
    distance: "${PARAM} km",
    error_message: "Une erreur s'est produite. Veuillez réessayer plus tard",
    input_hint: "p. ex. : ///pochade.nantir.courge",
    invalid_address_message: "Aucune adresse de 3 mots valide trouvée",
    voice_placeholder: "Dites une adresse de 3 mots...",
});
const gu = Object.freeze({
    correction_message: "તમારો મતલબ હતો?",
    distance: "${PARAM} કિમી",
    error_message: "એક ભૂલ આવી. પછીથી ફરી પ્રયત્ન કરો",
    input_hint: "દા. ત. ///બગી.રજાઈ.માસી",
    invalid_address_message: "કોઈ માન્ય what3words સરનામું મળ્યું નથી",
    voice_placeholder: "3 શબ્દનું સરનામું કહો ...",
});
const he = Object.freeze({
    correction_message: "אולי התכוונת?",
    distance: '‪${PARAM}‬ ק"מ',
    error_message: "אירעה שגיאה. יש לנסות שוב מאוחר יותר",
    input_hint: "לדוגמה: ///דירתך.מתבונן.גבוהה",
    invalid_address_message: "לא נמצאה כתובת 3 מילים תקינה",
    voice_placeholder: "אמרו בקול כתובת 3 מילים...",
});
const hi = Object.freeze({
    correction_message: "क्या आपका मतलब यह है?",
    distance: "${PARAM} कि.मी.",
    error_message: "कुछ गलत हुआ है। थोड़ी देर में कोशिश करें",
    input_hint: "जैसे ///वर्गों.बनने.जिताया",
    invalid_address_message: "कोई भी 3 शब्दों का पता नहीं मिला",
    voice_placeholder: "3 शब्दों का पता बोलिए...",
});
const hr = Object.freeze({
    correction_message: "Misliš li na ovo?",
    distance: "${PARAM} km",
    error_message: "Došlo je do pogreške. Molimo pokušaj ponovo kasnije",
    input_hint: "npr. ////usluge.izvođači.brižna",
    invalid_address_message: "Ova what3words adresa ne postoji",
    voice_placeholder: "Izgovori naglas adresu od 3 riječi",
});
const hu = Object.freeze({
    correction_message: "Erre gondoltál?",
    distance: "${PARAM} km",
    error_message: "Hiba történt. Próbálkozz később!",
    input_hint: "pl. ///termék.eperhab.rászáll",
    invalid_address_message: "Nem található érvényes háromszavas cím",
    voice_placeholder: "Mondj ki egy háromszavas címet...",
});
const id = Object.freeze({
    correction_message: "Apakah maksud Anda?",
    distance: "${PARAM} km",
    error_message: "Terjadi kesalahan. Mohon coba beberapa saat lagi",
    input_hint: "misalnya: ///kesenian.pemirsa.belang",
    invalid_address_message: "Alamat dalam 3 kata tidak ditemukan",
    voice_placeholder: "Ucapkan alamat dalam format 3 kata",
});
const it = Object.freeze({
    correction_message: "Intendevi?",
    distance: "${PARAM} km",
    error_message: "Si è verificato un errore. Riprovare più tardi.",
    input_hint: "p.es. ///mandali.avvera.sarò",
    invalid_address_message: "Non è stato trovato nessun indirizzo valido",
    voice_placeholder: "Di' un indirizzo di 3 parole...",
});
const ja = Object.freeze({
    correction_message: "こちらをお探しですか？",
    distance: "${PARAM} km",
    error_message: "エラーが発生しました。しばらくしてからもう一度お試しください。",
    input_hint: "例：///まてる。おおきめ。こっき",
    invalid_address_message: "有効な3ワードアドレスが見つかりません",
    voice_placeholder: "3ワードアドレスを言ってください",
});
const kk_cyrl = Object.freeze({
    correction_message: "Іздегеніңіз осы ма?",
    distance: "${PARAM} км",
    error_message: "Қате шықты. Кейін қайталап көріңіз",
    input_hint: "мысалы: ///жүзушілер.бағалас.еріткіш",
    invalid_address_message: "Мұндай what3words мекенжайы табылмады",
    voice_placeholder: "3 сөзді мекенжайды айтыңыз…",
});
const kk_latn = Object.freeze({
    correction_message: "Izdegenıñız osy ma?",
    distance: "${PARAM} km",
    error_message: "Qate şyqty. Keiın qaitalap körıñız",
    input_hint: "mysaly: ///jüzuşıler.bağalas.erıtkış",
    invalid_address_message: "Мұндай what3words мекенжайы табылмады",
    voice_placeholder: "3 sözdı mekenjaidy aityñyz…",
});
const km = Object.freeze({
    correction_message: "តើអ្នកចង់មានន័យបែបហ្នឹងមែនទេ?",
    distance: "${PARAM}គីឡូម៉ែត្រ",
    error_message: "មានបញ្ហាកើតឡើង។ សូម​ព្យាយាម​ម្តង​ទៀត​នៅ​ពេល​ក្រោយ",
    input_hint: "ឧទាហរណ៍៖  ///លាត់ដៃអាវ.ដាំពោត.គិតចេញ",
    invalid_address_message: "រកមិនឃើញអាសយដ្ឋាន what3words ដែលត្រឹមត្រូវនោះទេ។",
    voice_placeholder: "និយាយអាសយដ្ឋាន៣ពាក្យ",
});
const kn = Object.freeze({
    correction_message: "ನೀವು ಹೀಗೆ ಭಾವಿಸಿದಿರಾ?",
    distance: "${PARAM} ಕಿ.ಮೀ.",
    error_message: "ದೋಷ ಸಂಭವಿಸಿದೆ. ದಯವಿಟ್ಟು ನಂತರ ಮತ್ತೆ ಪ್ರಯತ್ನಿಸಿ",
    input_hint: "ಉದಾ. ///ನಗುವಿಗಾಗಿ.ತಡೆದು.ಓಡಾಡು",
    invalid_address_message: "ಯಾವುದೇ ಮಾನ್ಯ what3words ವಿಳಾಸ ಕಂಡುಬಂದಿಲ್ಲ",
    voice_placeholder: "ಯಾವುದೇ 3 ಪದಗಳ ವಿಳಾಸವನ್ನು ಹೇಳಿ...",
});
const ko = Object.freeze({
    correction_message: "아래의 주소를 찾으시나요?",
    distance: "${PARAM} km",
    error_message: "오류가 발생했습니다. 나중에 다시 시도해 주세요.",
    input_hint: "예: ///아무튼.묶은.튼다",
    invalid_address_message: "3단어 주소를 찾을 수 없습니다",
    voice_placeholder: "3단어 주소를 말하세요",
});
const lo = Object.freeze({
    correction_message: "ທ່ານໝາຍເຖິງ?",
    distance: "${PARAM} ກມ",
    error_message: "ມີຄວາມຜິດພາດເກີດຂຶ້ນ. ກະລຸນາລອງໃໝ່ໃນພາຍຫຼັງ",
    input_hint: "ເຊັ່ນ: ///ຕື່ນເດິກ.ຕົວຢ່າງ.ລອງກິນ",
    invalid_address_message: "ບໍ່ພົບທີ່ຢູ່ what3words ທີ່ຖືກຕ້ອງ",
    voice_placeholder: "ເວົ້າທີ່ຢູ່ 3 ຄຳສັບ…",
});
const ml = Object.freeze({
    correction_message: "നീ ഉദ്ദേശിച്ചോ ",
    distance: "${പരം} കി.മീ ",
    error_message: "ഒരു പിശക് സംഭവിച്ചു . വീണ്ടും ശ്രമിക്കുക ",
    input_hint: "ഉദാ. ///അങ്കണം.രമ്യം.ചാർത്തി",
    invalid_address_message: "സാധുതയുള്ള what33words വിലാസം കണ്ടെത്തിയില്ല ",
    voice_placeholder: "ഒരു 3 വാക്ക് വിലാസം പറയുക.. ",
});
const mn_mong = Object.freeze({
    correction_message: "Ta tègž xèlèx gèsèn üü?",
    distance: "${PARAM} км",
    error_message: "Aldaa garlaa. Daxin oroldož üznè üü.",
    input_hint: "Žišèè n’: ///homsog.durem.huchilt",
    invalid_address_message: "3 ügt xajag oldsongüj",
    voice_placeholder: "3 ügt xajagaa xèlnè üü",
});
const mn = Object.freeze({
    correction_message: "Та тэгж хэлэх гэсэн үү?",
    distance: "${PARAM} км",
    error_message: "Алдаа гарлаа. Дахин оролдож үзнэ үү.",
    input_hint: "Жишээ нь: ///хөмсөг.дүрэм.хучилт",
    invalid_address_message: "3 үгт хаяг олдсонгүй",
    voice_placeholder: "3 үгт хаягаа хэлнэ үү",
});
const mr = Object.freeze({
    correction_message: "तुम्हाला म्हणायचे होते का?",
    distance: "${PARAM} किमी",
    error_message: "एक चूक झाली. कृपया पुन्हा प्रयत्न करा",
    error_quota: "वापराची मर्यादा संपली. कृपया उच्च आणखीन उच्च प्रतीची योजना तपासा.",
    input_hint: "उदा. ///मजल.काढणे.चाळण",
    invalid_address_message: "कोणताही वैध what3words पत्ता सापडला नाही",
    invalid_suggestions: "कोणत्याही सूचना आढळल्या नाहीत. कृपया पुन्हा प्रयत्न करा.",
    voice_placeholder: "3 शब्दांचा पत्ता सांगा...",
});
const ms = Object.freeze({
    correction_message: "Adakah anda bermaksud?",
    distance: "${PARAM} km",
    error_message: "Ralat berlaku . Sila cuba sebentar lagi",
    input_hint: "cth. ///kapasiti.posisiku.diselangi",
    invalid_address_message: "Tidak alamat what3words yang sah dijumpai ",
    voice_placeholder: "Mengatakan satu alamat mengandungi 3 perkataan",
});
const ne = Object.freeze({
    correction_message: "यो भन्न खोज्नुभएको हो ? ",
    distance: "${PARAM} कि. मि ",
    error_message: "केहि त्रुटि देखा परेको  छ।  फेरि कोशिस गर्नुहोस्।  ",
    input_hint: "जस्तै. ///जोख.उसिने.हट्छु",
    invalid_address_message: "कुनै पनि मान्य तीन शब्दे ठेगाना भेटिएन  ",
    voice_placeholder: "कुनै तीन शब्दे ठेगाना भन्नुहोस्",
});
const nl = Object.freeze({
    correction_message: "Bedoelde je?",
    distance: "${PARAM} km",
    error_message: "Er is een fout opgetreden. Probeer het later nog eens.",
    input_hint: "bv. ///eren.lieveling.knipsel",
    invalid_address_message: "Geen geldig what3words adres gevonden",
    voice_placeholder: "Zeg een 3-woorden-adres",
});
const no = Object.freeze({
    correction_message: "Mente du: ?",
    distance: "${PARAM} km",
    error_message: "Det har oppstått en feil. Vennligst prøv igjen senere.",
    input_hint: "f.eks. ///donert.saget.kjøpte",
    invalid_address_message: "Finner ingen gyldig 3-ordsadresse",
    voice_placeholder: "Si en 3-ordsadresse",
});
const or = Object.freeze({
    correction_message: "ଆପଣଙ୍କ ମାନେ?",
    distance: "${PARAM} କି.ମି.",
    error_message: "ଏକ ତ୍ରୁଟି ଘଟିଛି। ଦୟାକରି ପରେ ପୁନର୍ବାର ଚେଷ୍ଟା କରନ୍ତୁ",
    input_hint: "ମାନେ ///ସକାଳଟି.ଟାପୁ.ପାଉଛ",
    invalid_address_message: "କୌଣସି ବୈଧ what3words ଠିକଣା ମିଳିଲା ନାହିଁ ",
    voice_placeholder: "ଗୋଟିଏ 3 ଶବ୍ଦ ଠିକଣା କୁହନ୍ତୁ  ",
});
const pa = Object.freeze({
    correction_message: "ਤੁਸੀਂ ਇਹ ਲੱਭ ਰਹੇ?",
    distance: "${PARAM} ਕਿ.ਮੀ.\n\n",
    error_message: "ਕੋਈ ਗੜਬੜ ਹੋਈ। ਬਾਅਦ 'ਚ ਮੁੜ-ਕੋਸ਼ਿਸ਼ ਕਰੋ",
    input_hint: "ਜਿਵੇਂ ///ਕਵੀਆਂ.ਰੁਕਣਾ.ਘੁੰਮਦੇ",
    invalid_address_message: "ਕੋਈ ਸਹੀ what3words ਪਤਾ ਨਹੀਂ ਮਿਲਿਆ",
    voice_placeholder: "ਕੋਈ 3 ਸ਼ਬਦੀ ਪਤਾ ਬੋਲੋ…",
});
const pl = Object.freeze({
    correction_message: "Czy chodziło Ci o?",
    distance: "${PARAM} km\n",
    error_message: "Wystąpił błąd. Spróbuj ponownie później",
    input_hint: "np. ///pojazd.podać.zwołać",
    invalid_address_message: "Nie znaleziono poprawnego adresu what3words",
    voice_placeholder: "Powiedz adres trzywyrazowy...",
});
const pt_br = Object.freeze({
    correction_message: "Você quis dizer?",
    distance: "${PARAM} km",
    error_message: "Occoreu um errro. Por favor, tente novamente",
    input_hint: "ex. ///votam.exclui.avalia",
    invalid_address_message: "Endereço de 3 palavras válido não encontrado",
    voice_placeholder: "Fale um endereço de 3 palavras",
});
const pt = Object.freeze({
    correction_message: "Querias dizer?",
    distance: "${PARAM} km",
    error_message: "Ocorreu um erro. Tenta novamente mais tarde",
    input_hint: "ex. ///votam.exclui.avalia",
    invalid_address_message: "Não foi encontrado um endereço de 3 palavras válido",
    voice_placeholder: "Diz um endereço de 3 palavras...",
});
const ro = Object.freeze({
    correction_message: "Voiai să spui?",
    distance: "${PARAM} km",
    error_message: "A apărut o eroare. Te rugăm să încerci din nou mai târziu",
    input_hint: "de ex. ///margine.murătură.dovadă",
    invalid_address_message: "Nu a fost găsită nicio adresă validă what3words",
    voice_placeholder: "Spune o adresă de 3 cuvinte...",
});
const ru = Object.freeze({
    correction_message: "Вы имели в виду?",
    distance: "${PARAM} км",
    error_message: "Произошла ошибка. Пожалуйста, повторите попытку позже",
    input_hint: "Например, ///довоенный.лазейка.шагнуть",
    invalid_address_message: "Такой адрес из 3 слов не найден",
    voice_placeholder: "Назовите адрес из 3 слов",
});
const si = Object.freeze({
    correction_message: "ඔබ අදහස් කළේ?",
    distance: "කි.මී. ${PARAM}",
    error_message: "දෝෂයක් ඇති විය. කරුණාකර පසුව නැවත උත්සාහ කරන්න",
    input_hint: "උදා. ///කවිච්චි.ආරංචි.බෝතලය",
    invalid_address_message: "වලංගු what3words ලිපිනයක් හමු නොවුණි",
    voice_placeholder: "what3words ලිපිනයක් කියන්න...",
});
const sk = Object.freeze({
    correction_message: "Mysleli ste toto?",
    distance: "${PARAM} km",
    error_message: "Vyskytla sa chyba, skúste to neskôr.",
    input_hint: "napr. ///dotknúť.cenové.tečúce",
    invalid_address_message: "Nenašla sa platná 3-slovná adresa",
    voice_placeholder: "Vyslovte 3-slovnú adresu…",
});
const sl = Object.freeze({
    correction_message: "Ste morda mislili ...?",
    distance: "${PARAM} km",
    error_message: "Prišlo je do napake. Prosimo, poskusite kasneje.",
    input_hint: "npr. ///lock.spout.radar",
    invalid_address_message: "Ne najdem veljavnega what3words naslova.",
    voice_placeholder: "Izgovorite what3words naslov ...",
});
const sr_cyrl_ba = Object.freeze({
    correction_message: "Јесте ли мислили...",
    distance: "${PARAM} km",
    error_message: "Дошло је до грешке. Покушајте поново касније",
    input_hint: "нпр. ///услуге.извођачи.брижна",
    invalid_address_message: "Није пронађена важећа адреса од 3 ријечи",
    voice_placeholder: "Реците адресу од 3 ријечи…",
});
const sr_cyrl_me = Object.freeze({
    correction_message: "Да ли сте мислили?",
    distance: "${PARAM} км",
    error_message: "Дошло је до грешке. Mолимо, покушајте касније.",
    input_hint: "нпр. ///услуге.извођачи.брижна",
    invalid_address_message: "Није пронађена важећа what3words адреса",
    voice_placeholder: "Реците адресу од 3 ријечи...",
});
const sr_cyrl = Object.freeze({
    correction_message: "Да ли сте мислили?",
    distance: "${PARAM} км",
    error_message: "Дошло је до грешке. Молимо покушајте касније",
    input_hint: "нпр. ///услуге.извођачи.брижна",
    invalid_address_message: "Није пронађена валидна what3words адреса од 3 речи",
    voice_placeholder: "Реците адресу од 3 речи...",
});
const sr_latn_me = Object.freeze({
    correction_message: "Da li ste mislili?",
    distance: "${PARAM} km",
    error_message: "Došlo je do greške. Molimo, pokušajte kasnije",
    input_hint: "npr. ///usluge.izvođači.brižna",
    invalid_address_message: "Nije pronađena važeća what3words adresa",
    voice_placeholder: "Recite adresu od 3 riječi...",
});
const sr = Object.freeze({
    correction_message: "Da li ste mislili?",
    distance: "${PARAM} km",
    error_message: "Došlo je do greške. Molimo pokušajte kasnije",
    input_hint: "npr. ///usluge.izvođači.brižna",
    invalid_address_message: "Nije pronađena validna what3words adresa od 3 reči",
    voice_placeholder: "Recite adresu od 3 reči...",
});
const sv = Object.freeze({
    correction_message: "Menade du?",
    distance: "S{PARAM} km",
    error_message: "Ett fel uppstod. Försök igen senare",
    input_hint: "t.ex. ///tabell.bryning.köer",
    invalid_address_message: "Ingen giltig 3-ordsadress hittades",
    voice_placeholder: "Säg en 3-ordsadress",
});
const sw = Object.freeze({
    correction_message: "ujumbe_sahihisha",
    distance: "umbali",
    error_message: "ujumbe_makosa",
    input_hint: "m.f. ///kuongea.kupewa.kumwoa",
    invalid_address_message: "ujumbe_anwani_haufai",
    voice_placeholder: "kishiko_sauti",
});
const ta = Object.freeze({
    correction_message: "நீங்கள் சொன்னீர்களா?",
    distance: "${PARAM} கிமீ",
    error_message: "ஒரு பிழை ஏற்பட்டது. தயவுசெய்து பிறகு முயற்சிக்கவும்",
    input_hint: "எ.கா. ///பதிவுகள்.ஓடவும்.பணமும்",
    invalid_address_message: "சரியான what3words முகவரி இல்லை",
    voice_placeholder: "ஒரு 3 வார்த்தை முகவரியைச் சொல்லுங்கள்...",
});
const te = Object.freeze({
    correction_message: "మీ ఉద్దేశ్యం?",
    distance: "${PARAM} కి.మీ.",
    error_message: "దోషం సంభవించింది. దయచేసి తర్వాత మళ్ళీ ప్రయత్నించండి",
    input_hint: "ఉదా ///ప్రతిదినము.జనాలు.గుణము",
    invalid_address_message: "చెల్లుబాటు అయ్యే what3words చిరునామా కనుగొనబడలేదు",
    voice_placeholder: "ఒక 3 పదాల చిరునామా చెప్పండి",
});
const th = Object.freeze({
    correction_message: "คุณหมายถึงคำนี้ใช่ไหม",
    distance: "${PARAM} กม.",
    error_message: "เกิดข้อผิดพลาด กรุณาลองอีกครั้ง",
    input_hint: "เช่น. ///ขายปลีก.เลขคู่.ใบบอน",
    invalid_address_message: "ไม่พบที่อยู่ 3 คำ",
    voice_placeholder: "พูดที่อยู่ 3 คำ",
});
const tr = Object.freeze({
    correction_message: "Şunu mu demek istediniz?",
    distance: "${PARAM} km",
    error_message: "Bir hata oluştu. Lütfen daha sonra tekrar deneyin.",
    input_hint: "ör. ///pati.ilerici.klas",
    invalid_address_message: "Geçerli bir what3words adresi bulunamadı",
    voice_placeholder: "3 kelimelik bir adres söyleyin...",
});
const uk = Object.freeze({
    correction_message: "Ви це мали на увазі?",
    distance: "${PARAM} км",
    error_message: "Сталася помилка. Повторіть спробу пізніше",
    input_hint: "Наприклад, ///коханий.прояви.залік",
    invalid_address_message: "Така адреса із 3 слів не знайдена",
    voice_placeholder: "Назвіть адресу із 3 слів",
});
const ur = Object.freeze({
    correction_message: "کیا آپ کا یہ مطلب تھا؟",
    distance: "‪${PARAM}‬ کیلومیٹر",
    error_message: "ایک خرابی واقع ہوئی۔ تھوڑی دیر میں پھر سے کوشش کریں ",
    input_hint: "مثال: ///نمودار.تسلی.دریاوں",
    invalid_address_message: "درست 3 لفظوں کا پتا نہیں ملا",
    voice_placeholder: "کوئی بھی 3 لفظوں کا پتا بولیں",
});
const vi = Object.freeze({
    correction_message: "Ý bạn là...",
    distance: "${PARAM} km",
    error_message: "Đã có lỗi xảy ra. Vui lòng thử lại sau",
    input_hint: "Ví dụ: ///thảo dược.thắt lưng.ghế nệm",
    invalid_address_message: "Không tìm thấy địa chỉ 3 từ phù hợp",
    voice_placeholder: "Hãy nói 3 từ địa chỉ...",
});
const xh = Object.freeze({
    correction_message: "Ubufuna ukuthi?",
    distance: "km",
    error_message: "Kwenzeke impazamo. Nceda uzame kwakhona emva kwethuba",
    input_hint: "umz. ///mculi.umgama.kukwenza",
    invalid_address_message: "Akukho dilesi ye-what3words efunyenweyo",
    voice_placeholder: "Biza idilesi ye-what3words",
});
const zh_cn = Object.freeze({
    correction_message: "您指的是这个位置吗？",
    distance: "${PARAM}千米",
    error_message: "发生错误。请稍后再试",
    input_hint: "例如 ///对流.门票.情感",
    invalid_address_message: "无法找到有效的三词地址",
    voice_placeholder: "说出一个三词地址...",
});
const zh_hk = Object.freeze({
    correction_message: "你指的是這位置嗎？",
    distance: "${PARAM} km",
    error_message: "發生錯誤，請稍後再試。",
    input_hint: "例如 ///對流.門票.情感",
    invalid_address_message: "找不到有效的三詞地址",
    voice_placeholder: "說出一個三詞地址",
});
const zh_tw = Object.freeze({
    correction_message: "你指的是這個位置嗎？",
    distance: "${PARAM} 公里",
    error_message: "發生錯誤，請稍後再試一次。",
    input_hint: "例如 ///對流.門票.情感",
    invalid_address_message: "找不到有效的三詞地址",
    voice_placeholder: "說出一個三詞地址",
});
const zu = Object.freeze({
    correction_message: "Ingabe kade ufuna ukuthi?",
    distance: "${PARAM} km",
    error_message: "Kwenzeke iphutha. Sicela uzame futhi emuva kwesikhathi",
    input_hint: "isb. ///thulisa.baniza.enkabeni",
    invalid_address_message: "Alikho ikheli elivumelekile lakwa-what3words elitholakele",
    voice_placeholder: "Isho ikheli lamagama awu-3…",
});

var resources = /*#__PURE__*/Object.freeze({
    __proto__: null,
    af: af,
    am: am,
    ar: ar,
    bg: bg,
    bn: bn,
    bs: bs,
    ca: ca,
    cs: cs,
    cy: cy,
    da: da,
    de: de,
    el: el,
    en: en,
    es: es,
    et: et,
    fa: fa,
    fi: fi,
    fr: fr,
    gu: gu,
    he: he,
    hi: hi,
    hr: hr,
    hu: hu,
    id: id,
    it: it,
    ja: ja,
    kk_cyrl: kk_cyrl,
    kk_latn: kk_latn,
    km: km,
    kn: kn,
    ko: ko,
    lo: lo,
    ml: ml,
    mn: mn,
    mn_mong: mn_mong,
    mr: mr,
    ms: ms,
    ne: ne,
    nl: nl,
    no: no,
    or: or,
    pa: pa,
    pl: pl,
    pt: pt,
    pt_br: pt_br,
    ro: ro,
    ru: ru,
    si: si,
    sk: sk,
    sl: sl,
    sr: sr,
    sr_cyrl: sr_cyrl,
    sr_cyrl_ba: sr_cyrl_ba,
    sr_cyrl_me: sr_cyrl_me,
    sr_latn_me: sr_latn_me,
    sv: sv,
    sw: sw,
    ta: ta,
    te: te,
    th: th,
    tr: tr,
    uk: uk,
    ur: ur,
    vi: vi,
    xh: xh,
    zh_cn: zh_cn,
    zh_hk: zh_hk,
    zh_tw: zh_tw,
    zu: zu
});

/**
 * Mapping of language codes. This is used to map the language code from phrase and the browser to the language code that the public api use.
 * Add more mapping here where needed.
 */
const LANGUAGE_MAP = {
    kk: { kk: "kk_cyrl" }, // kazakh
    mn: { mn: "mn" }, // mongolian
    zh: { "zh-cn": "zh_cn", zh: "zh_cn" }, // chinese
    zh_tr: { "zh-tw": "zh_tw", "zh-hk": "zh_hk" }, // chinese traditional
    pt: { "pt-pt": "pt_pt", "pt-br": "pt_br" }, // portuguese
    oo: { sr: "sr", hr: "hr", bs: "bs" }, // serbo-croatian
};
/**
 * Detect the language code based on the html lang and navigator language
 * Html tag is prioritised over the navigator language
 * NOTE: not aware of parent component's language property
 */
const detectLanguage = () => document.documentElement.getAttribute("lang") ||
    window.navigator.language ||
    DEFAULTS.language;
/**
 * Retrieves the phrase translations of a given what3words api language code
 * i.e.: `zh_tr` returns `zh_tw` translations
 * @param apiLangCode - language code recognized by the public api
 * @returns phrase translation object
 */
function getPhraseTranslations(apiLangCode, translationsResource) {
    var _a;
    const detectedLanguage = detectLanguage();
    const iso6392 = detectedLanguage.toLowerCase();
    const detectedCode = (_a = LANGUAGE_MAP[apiLangCode]) === null || _a === void 0 ? void 0 : _a[iso6392];
    const baseCode = distExports.baseLanguageCodeForISO6391(apiLangCode);
    const code = detectedCode || baseCode || DEFAULTS.language;
    let translations;
    if (isKey(resources, code)) {
        translations = (translationsResource !== null && translationsResource !== void 0 ? translationsResource : resources)[code];
    }
    return translations;
}
/**
 * Retrieves the language code that the public api uses based on the language code from the browser.
 * @param languageCode ISO-639-1 or ISO-639-2 language code
 * @returns supported language code for the public api server
 */
function getApiLanguageCodeFromLanguageMap(languageCode) {
    // Retrieve the language code from the mapping object
    // Scenario 1: the language code is in the mapping, then use the key from the mapped language code
    // Scenario 2: the language code is not in the mapping, then get the language code from the supported languages (if ISO-639-1 or ISO-639-2)
    // Scenario 3: the language code is from the supported languages that our api supports (i.e.: oo_la, oo_cy, kk_la etc.) then use the language code as it is.
    const apiLanguageCode = Object.keys(LANGUAGE_MAP).find((key) => { var _a; return (_a = LANGUAGE_MAP[key]) === null || _a === void 0 ? void 0 : _a[languageCode.toLowerCase()]; }) ||
        distExports.baseLanguageCodeForISO6391(languageCode) ||
        (distExports.validLanguage(languageCode) && languageCode);
    // Scenario 4: the language code is not in the mapping and not in the supported languages,
    //             then use `DEFAULTS.language` which is `en` and warn the user that it's defaulting to `en`
    if (!apiLanguageCode) {
        console.warn(`Invalid or unsupported language (\`${languageCode}\`), using default language (\`${DEFAULTS.language}\`) for autosuggest results instead.`);
    }
    return apiLanguageCode || DEFAULTS.language;
}
/**
 * Translates the given key from phrase translation resources
 * @param key             translation key
 * @param opt             translation options
 * @param opt.param       value to interpolate into PHRASE_PARAMETER_PLACEHOLDER if present in translation key
 * @param opt.language    override auto-detected browser language used to query translation resources
 * @param opt.strict      if false, silences translation key runtime errors
 * @returns               translation of the given key
 * @throws                translation error
 */
function t(key, opt = {}) {
    const { param = "", language = detectLanguage(), strict = true, translationsResource, } = opt;
    const apiLanguageCode = getApiLanguageCodeFromLanguageMap(language);
    const translations = getPhraseTranslations(apiLanguageCode, translationsResource);
    let translation = "";
    if (translations && isKey(translations, key)) {
        translation = translations[key];
    }
    if (!translation && strict) {
        throw new Error(`No translations found for "${key}" key. Please add the translation to ${language} or "${DEFAULTS.language}" language file.`);
    }
    // if param is a string, attempt to inject into translation placeholder
    if (typeof param === "string" && param.length > 0) {
        if (translation) {
            // inject if translation exists
            translation = translation.replace(PHRASE_PARAMETER_PLACEHOLDER, param);
        }
        else {
            // if not, set translation to the param
            translation = param;
        }
    }
    return translation;
}
/**
 * Resolves the language code based on the provided language code.
 * This will validate the language code if it's supported by our what3words api.
 * Uses `en` as the default language code if no language code is provided or if it's not on the list of supported languages.
 */
function resolveLanguageCode(languageCode) {
    if (!languageCode)
        return getApiLanguageCodeFromLanguageMap(detectLanguage());
    if (!distExports.validLanguage(languageCode)) {
        console.warn(`Invalid or unsupported language (\`${languageCode}\`), using default language (\`${DEFAULTS.language}\`) for autosuggest results instead.`);
        return DEFAULTS.language;
    }
    return languageCode.toLowerCase();
}

export { resolveLanguageCode as r, t };
