export declare const SELECTORS: {
    input: string;
    suggestions: string;
    script: string;
};
export declare enum ScriptInitParameter {
    KEY = "key",
    BASEURL = "baseUrl",
    VERSION = "version",
    CALLBACK = "callback",
    HEADERS = "headers"
}
export declare const ScriptInitParameters: ScriptInitParameter[];
export declare enum Variant {
    DEFAULT = "default",
    INHERIT = "inherit"
}
export declare const DEFAULTS: {
    emptyString: string;
    null: null;
    true: boolean;
    false: boolean;
    name: string;
    prefix: string;
    threeWordAddress: string;
    required: boolean;
    variant: Variant;
    typeaheadDelay: number;
    iconVisible: boolean;
    iconSize: number;
    iconColor: string;
    textColor: string;
    addressSize: number;
    symbolSize: number;
    readonly placeholder: string;
    errorMessage: string;
    fatalErrorMessage: string;
    serviceErrorMessage: string;
    headers: string;
    base_url: string;
    language: string;
    nResults: number;
    returnCoordinates: boolean;
    apiRequest: null;
    options: never[];
    showOptions: boolean;
    option: null;
    loading: boolean;
    loaded: boolean;
    selected: boolean;
    target: string;
    tooltipLocation: string;
    bounds: {
        south: number;
        west: number;
        north: number;
        east: number;
    };
    center: {
        lat: number;
        lng: number;
    };
};
export declare const W3W_REGEX: RegExp;
export declare const W3W_TEXTAREA_REGEX: RegExp;
export declare const SESSION_ID_KEY = "component-session";
export declare const MAP_SCRIPT_ID = "gmaps-api";
export declare const RETRIES = 3;
export declare const MAP_SELECTOR = "div[slot=map]";
export declare const SEARCH_CONTROL_SELECTOR = "[slot=search-control]";
export declare const MAP_TYPE_CONTROL_SELECTOR = "[slot=map-type-control]";
export declare const ZOOM_CONTROL_SELECTOR = "[slot=zoom-control]";
export declare const CURRENT_LOCATION_CONTROL_SELECTOR = "[slot=current-location-control]";
export declare const AUTOSUGGEST_SELECTOR = "what3words-autosuggest";
export declare const TOP_LEFT = 1;
export declare const SELECTED_ZOOM_LEVEL = 19;
export declare const MIN_GRID_ZOOM_LEVEL = 18;
export declare const MARKER_SRC = "https://what3words.com/map/marker.png";
export declare const PHRASE_PARAMETER_PLACEHOLDER = "${PARAM}";
export declare const W3W_TEXTAREA_PROPERTIES: string[];
