import type { ApiClientConfiguration, Transport, What3wordsService } from "@what3words/api";
import { AutosuggestClient, AvailableLanguagesClient, ConvertTo3waClient, ConvertToCoordinatesClient, GridSectionClient } from "@what3words/api";
export interface SDK {
    api: What3wordsService;
    utils: {
        validAddress: (value: string) => boolean;
    };
}
export declare const what3wordsClients: {
    autosuggest: (apiKey?: string, config?: ApiClientConfiguration, transport?: Transport) => AutosuggestClient;
    availableLanguages: (apiKey?: string, config?: ApiClientConfiguration, transport?: Transport) => AvailableLanguagesClient;
    convertTo3wa: (apiKey?: string, config?: ApiClientConfiguration, transport?: Transport) => ConvertTo3waClient;
    convertToCoordinates: (apiKey?: string, config?: ApiClientConfiguration, transport?: Transport) => ConvertToCoordinatesClient;
    gridSection: (apiKey?: string, config?: ApiClientConfiguration, transport?: Transport) => GridSectionClient;
};
export declare const sdk: Readonly<SDK>;
