import type { Coordinates } from "@what3words/api";
/**
 * Reference: https://www.totaltypescript.com/iterate-over-object-keys-in-typescript#solution-2-type-predicates
 */
export declare function isKey<T extends object>(x: T, k: PropertyKey): k is keyof T;
/**
 * Converts a string of coordinate pair values into an array of coordinate objects
 * @param coordinatesString A string of coordinate pair values e.g. `67.234,-42.00,24.24,47.42`
 */
export declare const convertToCoordinates: (coordinatesString: string) => Coordinates[];
/**
 * Parses coordinate string and returns as an object with floating values
 * @param lat A coordinate-like string
 * @param lng A coordinate-like string
 * @returns object
 */
export declare const parseCoordinates: (lat: string, lng: string) => Coordinates;
/**
 * Validates if a value or array is empty
 * @param input the value or array to validate if empty
 */
export declare const isEmpty: (input: null | undefined | string | unknown[]) => boolean;
/**
 * Retrieves API options that are settable via query parameters in the request of the SDK. This function retrieves and
 * returns an object with all found parameters if any exist
 * @returns object
 */
export declare function getScriptInitOptions(): Record<string, unknown>;
